theory Ex05_Tut2_Sol
  imports "HOL-IMP.Big_Step"
begin

fun deskseq where
"deskseq SKIP c2 = c2" |
"deskseq c1 SKIP = c1" |
"deskseq c1 c2 = c1;;c2"

lemma seq_equiv:
  assumes "c1 \<sim> c1'"
  assumes "c2 \<sim> c2'"
  shows "c1;; c2 \<sim> c1';;c2'"
  using assms by auto

lemma deskseq_equiv: "deskseq c1 c2 \<sim> c1;;c2"
  by (induction c1 c2 rule: deskseq.induct) auto

lemma if_equiv:
  assumes "c1 \<sim> c1'"
  assumes "c2 \<sim> c2'"
  shows "IF b THEN c1 ELSE c2 \<sim> IF b THEN c1' ELSE c2'"
  using assms by auto

fun deskif where
"deskif b SKIP SKIP = SKIP" |
"deskif b c1 c2 = IF b THEN c1 ELSE c2"

lemma deskif_equiv: "deskif b c1 c2 \<sim> IF b THEN c1 ELSE c2"
  by (induction b c1 c2 rule: deskif.induct) auto

fun deskip :: "com \<Rightarrow> com" where
  "deskip (c1;;c2) = deskseq (deskip c1) (deskip c2)" |
  "deskip (IF b THEN c1 ELSE c2) = deskif b (deskip c1) (deskip c2)" |
  "deskip (WHILE b DO c) = WHILE b DO deskip c" |
  "deskip c = c"

lemma "deskip c \<sim> c"
  apply (induction c rule: deskip.induct)
  apply (simp_all only: deskip.simps)
  (* proof follows since (\<sim>) is a congruence *)
  using sim_refl sim_trans seq_equiv if_equiv deskseq_equiv deskif_equiv sim_while_cong
  by presburger+

end